console.log("hello world background todo something~");

import {
    backTwitterPinLoginToken,
    backTwitterPinLoginCode,
} from "../logic/twitter.js";

import { setChromeStorage, getChromeCookie, LANDING_PAGE, setChromeCookie, removeChromeCookie, LANDING_PAGE_MIND } from "../uilts/chromeExtension";
import { guid } from '../uilts/help.js'

chrome.runtime.onInstalled.addListener(onInstalledMethod);

chrome.runtime.onMessage.addListener(onMessageMethod);

function onInstalledMethod() {
    let cookiesParams = {
        name: 'pickup_info',
        url: 'https://de-net-test.piaoquantv.com'
    }
    getChromeCookie(cookiesParams, (res) => {
        let { postNickName, srcContentId } = res;
        if (res && postNickName && srcContentId) {
            let url = `https://twitter.com/${postNickName}/status/${srcContentId}`
            chrome.tabs.create({
                url
            });
            removeChromeCookie(cookiesParams)
        } else {
            chrome.tabs.create({
                url: "https://twitter.com",
            });
            let { isOnToolbar } = checkIsPinned();
            console.log(isOnToolbar);
        }
    })
    getChromeCookie(LANDING_PAGE_MIND, (res_arr) => {
        // 没有cookie
        if (res_arr && res_arr.length) {
            setChromeStorage({ mid: JSON.stringify(res_arr[0]) })
        } else {
            let _params = {
                mid: guid()
            }
            setChromeCookie(LANDING_PAGE, { 'mid': _params.mid })
            setChromeStorage({ mid: JSON.stringify(_params) })
        }
    })

    // 无刷新插入js
    chrome.tabs.query({}, (tab) => {
        for (let i in tab) {
            if (tab[i].url.indexOf('twitter.com') >= 0) {
                chrome.scripting.executeScript({
                    target: { tabId: tab[i].id },
                    files: ['js/content.js'],
                }, () => {
                    setTimeout(() => {
                        setChromeStorage({ executeScript: JSON.stringify({executeScript:1}) })    
                    }, 2000);
                    
                })
            }
        }
    })
}

async function checkIsPinned(){
    let userSettings = await chrome.action.getUserSettings();
    console.log('userSettings', userSettings.isOnToolbar)
}

function onMessageMethod(req, sender, sendResponse) {
    if (req) {
        switch (req.method) {
            case "POPUP_LOGIN":
                popupLogin(sendResponse);
                break;
            case "POPUP_PUBLISH_TWITTER_RED_PACK":
                setChromeStorage({
                    popupShowPublishDialog: JSON.stringify({
                        show: true,
                        srcContent: req.data.srcContent,
                        postId: req.data.postId
                    }),
                });
                chrome.tabs.create({
                    url: "https://twitter.com",
                });
                break;
        }
    }
    return true; // remove this line to make the call sync!
}

//
function popupLogin() {
    backTwitterPinLoginToken();
}

// 消息通讯
chrome.runtime.onConnect.addListener(function (port) {
    port.onMessage.addListener(function (res) {
        switch (res.state) {
            case "CONTENT_SEND_CODE":
                port.postMessage({
                    state: "BACK_TWITTER_LOGIN_SUCCESS",
                });
                backTwitterPinLoginCode(res.code);
                break;
            case "CONTENT_TWITTER_LOGIN":
                backTwitterPinLoginToken();
                break;
        }
    });
});
